#!/bin/sh
#
# lvinfo -- report interesting information about AIX filesystems and logical volumes
#
# $1 = target filesystem name (/dev/filesystem -- not "mounted on")
#
# i.e.
#
#    lvinfo backupdb BackupDBLV BackupDBVG
#
# Filesystem    512-blocks      Free %Used    Iused %Iused Mounted on
# /dev/hd4          786432    401824   49%    11104    20% /
# /dev/hd2         5242880    376448   93%    47731    53% /usr
# /dev/hd9var      2097152   1130096   47%    11172     9% /var
# /dev/hd3         1572864   1562016    1%       73     1% /tmp
# /proc                  -         -    -         -     -  /proc
# /dev/hd10opt     5242880   2555536   52%    21961     8% /opt
# /dev/locallv     2097152   2096112    1%       10     1% /usr/local
# /dev/rootlv      1048576   1042696    1%       21     1% /root
# /dev/lv1msb01   10485760  10483504    1%        4     1% /mksysb_dir
# /dev/ai_lv     109051904 108608608    1%        6     1% /ai
# /dev/bi_lv      69206016  55817224   20%        8     1% /bi
# /dev/db_lv    2359296000 1909960456  20%   716996     1% /db
# /dev/dbtmp_lv  104857600 104430768    1%        5     1% /dbtmp


FSNAME=$1

OSLOGDIR=${LOGDIR-/tmp}/osinfo.`date +%Y.%m.%d`

LOGFILE=${OSLOGDIR-.}/`basename $1`.lvinfo

#LVNAME=`lslv $1 | head -1 | awk '{print $3}'`

LVNAME=`df | grep "$1" | awk '{print $1}' |  cut -d / -f 3`

VGNAME=`lslv $LVNAME | head -1 | awk '{print $6}'`

echo "Results are in ${LOGFILE}"
echo ""

echo `date` `uname -a` > ${LOGFILE}
echo ""         >> ${LOGFILE}
df -g | head -1 >> ${LOGFILE}
df -g | grep $1 >> ${LOGFILE}
echo ""         >> ${LOGFILE}
lslv $LVNAME    >> ${LOGFILE}
echo ""         >> ${LOGFILE}
lsvg $VGNAME    >> ${LOGFILE}
echo ""         >> ${LOGFILE}
lsvg -p $VGNAME >> ${LOGFILE}

