#!/bin/sh
# bin/maintenance.sh
# mark b 040720 - move scripted case logic to 4GL for use across platforms
#

. #ENVPT3#/bin/protopenv

umask 0		# this is important!  util/dbmonitor.p must be able to delete $TMPDIR/MAINTENANCE at the end of the maint period

usage() {
	echo "usage: $0 [ on #hours | off | status ]"
}

if [ $# = 0 ]
then
   usage
   exit 1
fi

if [ "$1" != "on" ] && [ "$1" != "off" ] && [ "$1" != "status" ]
then
   usage
   exit 1
fi

if [ "$1" == "on" ]
then
   typeset -i Duration
   let Duration=$2 2>/dev/null;RC=$?
   if [ $RC != 0 ]
   then
      echo "Duration not an integer > 0"
      usage
      exit 1
   fi
fi

TMPDIR=${TMPDIR-/tmp}
LOGDIR=${LOGDIR-/tmp}

#UN-comment for DEBUG
#ECHO=echo

cd ${PROTOP}

if [ ! -d ${TMPDIR} ]
then
   mkdir ${TMPDIR}
fi

if [ ! -d ${LOGDIR} ]
then
   mkdir ${LOGDIR}
fi

if [ ! -s $PROTOP/etc/custid.cfg ]
then
   echo "No custid in $PROTOP/etc/custid.cfg"
   exit 1
fi
CUSTID=$(cat $PROTOP/etc/custid.cfg)


# pass the validated args to util/maintenance.p for generic 4GL execution

${DLC}/bin/_progres -1 -b -d ymd -p util/maintenance.p ${PFLIST} -param "${1}|${2}|${TMPDIR}|${LOGDIR}|${CUSTID}|${PTHOST}" | tee -a ${LOGDIR}/maintenance.log



### finis
